//  Copyright (c) 2012 Dennco Project
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

//
//  Created by tkawata on 12/11/2011.
//

#include "TKContainer.h"
#include "TKCell.h"


TKContainer::~TKContainer()
{
    for ( TKCellMap::iterator it = mCells.begin(); it != mCells.end(); ++it ) {
        delete it->second;
    }
    mCells.clear();
    mInterfaceCells.clear();
}

TKCell* TKContainer::getCell(std::string theFQNName)
{
    TKCellMap::iterator it = mCells.find(theFQNName);
    if (it == mCells.end())
    {
        return NULL;
    }
    else
    {
        return it->second;
    }
}

TKCell* TKContainer::getInterfaceCell(std::string theFQNName)
{
    TKCellMap::iterator it = mInterfaceCells.find(theFQNName);
    if (it == mInterfaceCells.end())
    {
        return NULL;
    }
    else
    {
        return it->second;
    }
}

TKCellCode* TKContainer::getCellCode(std::string theCellCodeName)
{
    TKCellCodeMap::iterator it = mCellCodes.find(theCellCodeName);
    if (it == mCellCodes.end())
    {
        return NULL;
    }
    else
    {
        return it->second;
    }
}
