//  Copyright (c) 2012 Dennco Project
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

//
//  Created by tkawata on 12/11/2011.
//

#ifndef __INCLUDE_TKCONTAINER__
#define __INCLUDE_TKCONTAINER__

#include <string>
#include <map>

class TKCell;
class TKCellCode;

typedef std::map<std::string, TKCell*> TKCellMap;
typedef std::map<std::string, TKCellCode*> TKCellCodeMap;

class TKContainer
{
public:
	
	TKContainer() {};
	virtual ~TKContainer();

    const TKCellMap* getCells() { return &mCells; } 
    const TKCellCodeMap* getCellCodes() { return &mCellCodes; }
    void setContentPath(std::string contentPath) { mContentPath = contentPath; }
    std::string getContentPath() { return mContentPath; }
	TKCell* getCell(std::string theFQNName);
	TKCell* getInterfaceCell(std::string theFQNName);
	TKCellCode* getCellCode(std::string theCellCodeName);
	
	virtual TKCell* createCell(std::string theLocation, std::string theName, TKCellCode *cellCode, std::string startupString) = 0;
	virtual TKCellCode* createCellCode(std::string theName, std::string theAPIType, std::string code) = 0;
    	
	virtual bool doTick(float time) = 0;
	
	virtual void setValue(std::string key, float value) = 0;
	inline virtual float getValue(std::string key) = 0;

protected:
	TKCellMap       mCells;
    TKCellMap       mInterfaceCells;
    TKCellCodeMap   mCellCodes;
    std::string     mContentPath;
	
};
#endif