//  Copyright (c) 2012 Dennco Project
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

//
//  Created by tkawata on 12/30/2011.
//

#include "TKReceptor.h"
#include "TKAxon.h"
#include "TKUICell.h"

const std::string TKUICell::RECEPTORNAME = "input";

bool TKUICell::doTick(float time)
{
    TKReceptorMap::iterator it = mReceptors.find(RECEPTORNAME);
    if (it != mReceptors.end())
    {
        mIsInput = true;
        TKReceptor *receptor = it->second;
        float v = receptor->getValue();
        mAxon->value = v;
    }

    return true;
}

void TKUICell::setValue(float value)
{
    mAxon->value = value;
    
}

float TKUICell::getValue()
{
    return mAxon->value;
}

