//
//  AppDelegate.m
//  dennco
//
//  Created by tkawata on 12/26/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#include "TKJSContainer.h"
#include "DNContainerBuilder.h"
#include "DNDirectory.h"
#include "DNFileList.h"
#include "TKLog.h"

#import "AppDelegate.h"

@implementation AppDelegate

@synthesize window = _window;


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    console = new TKConsole();
    TKLog::setDestination(console);

    // Insert code here to initialize your application
    NSURL *path = [[NSURL alloc]initWithString:NSHomeDirectory()];
    [uiPathControl setURL:path];
}

-(IBAction)pathChanged:(id)sender
{
    NSURL *newURL = [uiPathControl URL];
}

-(IBAction)doInit:(id)sender
{
    
    if (container)
    {
        delete container;
    }
    container = new TKJSContainer();
    
    DNContainerBuilder builder(container);
  
    const char *path = [[[uiPathControl URL]path] UTF8String];
    builder.buildContainerFromXHTML(path);
    
    
}

-(IBAction)doStart:(id)sender
{
    engine = new DNEngine(container);
    engine->setTickIntervalSec(1.0);
    engine->startHTTPServer(9080);
}

-(IBAction)doStop:(id)sender
{
    
}


@end
